#include <stdlib.h>
#include "stack.h"

struct stack *stack_init()
{
    struct stack *st;

    if (!(st = malloc(sizeof(struct stack))))
	return 0;

    st->count = 0;
    st->top = 0;

    return st;
}

void stack_destroy(struct stack *stack)
{
    struct stackitem *node = stack->top, *tmp;

    while (node) {
	tmp = node;
	node = node->next;
	free(tmp);
    }
    
    free(stack);
}

int stack_push(struct stack *st, void *data)
{
    struct stackitem *si;

    if (!(si = malloc(sizeof(struct stackitem))))
	return -1;

    si->data = data;
    si->next = st->top;
    st->count++;
    st->top = si;

    return 0;
}

void *stack_pop(struct stack *st)
{
    void *data;
    struct stackitem *si;

    if (!st || !st->top)
	return 0;

    si = st->top;
    st->top = si->next;
    st->count--;
    data = si->data;
    free(si);

    return data;
}

void *stack_top(struct stack *st)
{
    if (st->top)
	return st->top->data;
    else
	return 0;
}
